module Main where

import System
import System.IO
import System.IO.Error
import System.IO.Unsafe
import System.Posix
import Monad
import Network
import Network.Socket (sIsConnected)
import Control.Concurrent
import Control.Concurrent.MVar
import Control.Exception hiding (catch)

main = do installHandler sigPIPE Ignore Nothing
          args <- getArgs
          let port = if null args then error "No port given" 
                     else (read $ args!!0)::Int
          let numThreads = if length args < 2 then error "Num Threads not given."
                           else (read $ args!!1)::Int
          mapM_ (\x -> connect $ PortNumber $ fromIntegral port) [1..numThreads]
          getChar >> return ()
     where
     connect port = forkIO $ do h <- connectTo "localhost" port
                                hSetBuffering h LineBuffering
                                ts <- fmap show myThreadId
                                hPutStrLn h $ "Remote Connected from: "++ts
                                threadWaitRead (toEnum 1)
                                putStrLn $ "Closing "++show h
                                hClose h
